<template>
  <div class="sidebar bg-darkLayoutStorm" :class="{ open: sidebar.isSidebarOpen }">
    <div class="logo-details bg-darkLayoutStorm">
      <div class="logo_name">
        <span v-if="sidebar.isSidebarOpen">Sott</span>
      </div>
      <i id="btn" :class="`bx ${menuBtnChange()}`" @click="toggleSidebar" />
    </div>

    <div class="main-section">
      <!-- div -->
      <div class="quadrat1"></div>
      <div class="quadrat2"></div>
      <!-- div -->

      <ul class="nav-list">
        <li v-for="(route, index) in sidebarRoutes" :key="index" :class="(isOpenLink[index] &&
          sidebar.isSidebarOpen &&
          'open_dropdown multiple-item') ||
          ($route.path === route.path && 'bg-white/5')
          ">
          <a class="link" @click="toggleDropdwon(route, index)">
            <i :uk-icon="route.icon" class="flex w-[30px] items-center justify-center text-white" />
            <span class="links_name">{{ route.name }}</span>

            <button v-if="route.child" class="links_dropdown_arrow">
              <svg width="15" height="15" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M19 9L12 15L5 9" stroke="#ffffff" stroke-width="2" stroke-linecap="round"
                  stroke-linejoin="round" />
              </svg>
            </button>
          </a>
          <span v-if="route.child" class="tooltip">
            <router-link v-for="(child, index) in route.child" :key="index" active-class="active-route" :to="child.path">
              <i :uk-icon="child.icon" class="flex w-[30px] items-center justify-center text-white" />
              {{ child.name }}
            </router-link>
          </span>
          <span v-else class="tooltip">
            <router-link active-class="active-route" :to="route.path">
              <i uk-icon="chevron-double-right" class="flex w-[30px] items-center justify-center text-white" />
              <span class="text-white">{{ route.name }}</span>
            </router-link>
          </span>
        </li>

        <li class="profile bg-darkLayoutStorm cursor-pointer md:hidden" @click="logout">
          <div class="profile-details">
            <div class="name_job">
              <div class="name">Logout</div>
            </div>
          </div>
          <i id="log_out" class="bg-darkLayoutStorm absolute top-4">
            <span uk-icon="sign-out" />
          </i>
        </li>
      </ul>
    </div>
  </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from "vue";
import { useSidebarStore } from "@/stores/layoutConfig.ts";
import sidebarRoutes from "@/navigation/vertical/index";
import { useRouter } from "vue-router";
import { logout } from "@/auth/jwtService";

const sidebar = useSidebarStore();

let isOpenLink = ref<boolean[]>([]);
const router = useRouter();

// router.beforeEach(() => {
//   const modal = document.getElementsByClassName("uk-modal");
//   const modalArray = Array.from(modal) as Element[];
//   modalArray.forEach((el) => el.remove());
// });

const toggleSidebar = () => {
  sidebar.toggleSidebar();
  menuBtnChange();
};


const menuBtnChange = () => {
  return sidebar.isSidebarOpen ? "bx-menu-alt-right" : "bx-menu";
};

const toggleDropdwon = (route, index): any => {
  if (route && !route.child) return router.push(route.path);

  isOpenLink.value[index] = !isOpenLink.value[index];
};

onMounted(() => {
  isOpenLink.value = new Array(sidebarRoutes.length).fill(false);
});
</script>
